package com.gmail.josemanuelgassin.DeathMessages;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class _DeathMessages extends JavaPlugin{
	Logger logger = Logger.getLogger("Minecraft");
	PluginDescriptionFile pdfFile;
	
//============================================= Instancias
	public _DeathMessages main = this;
	Util_VersionChecker u_VersionChecker = new Util_VersionChecker(main);
	
//============================================= Variables
	String nombrePlugin;
	String versiónPlugin;
	FileConfiguration FC;
	int mensajesPvP = 2;
	boolean debug = false;
	
//============================================= Cabeceras
	String label = (ChatColor.DARK_RED + "[" + ChatColor.GOLD + " Death Messages " + ChatColor.DARK_RED + "]" + ChatColor.WHITE + " - ");
	
//============================================= Listas
	List<String> MundosEnSilencio = new ArrayList<String>();
	List<String> MundosVinculados = new ArrayList<String>();
	
//============================================= DISABLE / ENABLE
	@Override
	public void onDisable(){
		if(pdfFile == null)pdfFile = getDescription();
		logger.info("<<[ " + pdfFile.getName() + " ]>> " + " [ Version ]=[ " + pdfFile.getVersion() + " ] [ Disabled! ]");
	}
	
	@Override
	public void onEnable(){
		pdfFile = getDescription();
		cargarCFG(true);
		
		PluginManager pm = Bukkit.getPluginManager();
		pm.registerEvents(new Listener_Jugador(this), this);
		if(FC.getBoolean("Generic_Messages"))pm.registerEvents(new Listener_General(this), this);
		
		logger.info("<<[ " + nombrePlugin + " ]>> " + " [ Version ]=[ " + versiónPlugin + " ] [ Successfully Loaded! ]");
	}
	
//============================================= Comandos
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){
		if(commandLabel.equalsIgnoreCase("deathmessages") || commandLabel.equalsIgnoreCase("dm")){
			if(!noPerm(sender, "dm.admin.commands"))return true;
			if(args.length == 1){
				if(args[0].equalsIgnoreCase("reload")){
					main.cargarCFG(false);
					sender.sendMessage(label + ChatColor.GREEN + "Config.yml Reloaded !");
					return true;
				}
			}
		}
		return false;
	}
	
//============================================= Cargar Configuración
	void cargarCFG(boolean inicio){
		// Base del Plugin
		pdfFile = getDescription();
		nombrePlugin = pdfFile.getName();
		versiónPlugin = pdfFile.getVersion();
		
		// Configuración y Variables
		if(inicio)saveDefaultConfig();
		if(!inicio)reloadConfig();
		
		FC = getConfig();
		
		// Comprobar Versiones
		u_VersionChecker.configVersionChecker();
		
		// Otros
		MundosEnSilencio = FC.getStringList("Silenced_Worlds");
		if(FC.getBoolean("Linked_Worlds.Enable"))MundosVinculados = FC.getStringList("Linked_Worlds.World_List");
		mensajesPvP = FC.getInt("PvP_Death_Messages_Handling");
		debug = FC.getBoolean("Debug");
	}
	
//================= Comprobar si el sender tiene permiso
	boolean noPerm(CommandSender s, String p){
		if(s.hasPermission(p))return true;
		s.sendMessage(label + ChatColor.RED + "You don't have the required permissions for this command !");
		return false;
	}

//============================================= Formateador
	String formateador(String frase){
		frase = frase.replaceAll("&", "§");
		frase = frase.replaceAll("%\\[n\\]", "ñ");
		frase = frase.replaceAll("%\\[a1\\]", "á");
		frase = frase.replaceAll("%\\[a2\\]", "à");
		frase = frase.replaceAll("%\\[a3\\]", "à");
		frase = frase.replaceAll("%\\[a4\\]", "å");
		frase = frase.replaceAll("%\\[a5\\]", "ä");
		frase = frase.replaceAll("%\\[e1\\]", "é");
		frase = frase.replaceAll("%\\[e2\\]", "è");
		frase = frase.replaceAll("%\\[e3\\]", "ê");
		frase = frase.replaceAll("%\\[i1\\]", "í");
		frase = frase.replaceAll("%\\[i2\\]", "ì");
		frase = frase.replaceAll("%\\[i3\\]", "î");
		frase = frase.replaceAll("%\\[o1\\]", "ó");
		frase = frase.replaceAll("%\\[o2\\]", "ò");
		frase = frase.replaceAll("%\\[o3\\]", "ô");
		frase = frase.replaceAll("%\\[o4\\]", "ö");
		frase = frase.replaceAll("%\\[o5\\]", "ø");
		frase = frase.replaceAll("%\\[u1\\]", "ú");
		frase = frase.replaceAll("%\\[u2\\]", "ù");
		frase = frase.replaceAll("%\\[u3\\]", "û");
		frase = frase.replaceAll("%\\[u4\\]", "ü");
		frase = frase.replaceAll("%\\[simbol1\\]", "☠");
		frase = frase.replaceAll("%\\[ae\\]", "æ");
				
		return frase;
	}
	
//============================================= Comunicador de Mundos (¿A qué mundos corresponde enviar el mensaje?)
	void comunicadorDeMundos(String mensaje, String mundoOrigen){
		List<World> mundosAComunicar = new ArrayList<World>();
		
		if(FC.getBoolean("Linked_Worlds.Enable")){
			if(MundosVinculados.contains(mundoOrigen)){
				
				Iterator<String> iterador = MundosVinculados.iterator();
				while(iterador.hasNext()){
					String mundo = iterador.next();
					World w = null;
					// comprobar que el mundo exista, sino lanzará errores más tarde
					try{
						w = Bukkit.getWorld(mundo);
						Bukkit.getWorld(mundo).getName(); // check para comprobar que el mundo existe
					}catch(Exception ex){continue;}
					
					mundosAComunicar.add(w);
				}
			}
			// si el mundo no está en la lista de mundos comunicados, ponerlo a él como único mundo receptor
			if(mundosAComunicar.isEmpty())mundosAComunicar.add(Bukkit.getWorld(mundoOrigen));
		}
		// si la lista de mundos sigue vacía esque no está activo el módulo de linkeo de mundos y se aplica a todos, los mundos en silencio serán eliminados más tarde.
		if(mundosAComunicar.isEmpty())mundosAComunicar = Bukkit.getWorlds();
		this.broadcaster(mensaje, mundosAComunicar);
	}
	
//============================================= Broadcaster (Elimina de paso los mundos en silencio)
	void broadcaster(String mensaje, List<World> mundosAComunicar){
		Iterator<World> iteradorDeMundos = mundosAComunicar.iterator();
		while(iteradorDeMundos.hasNext()){
			World mundo = iteradorDeMundos.next();
			if(!MundosEnSilencio.isEmpty())if(MundosEnSilencio.contains(mundo.getName()))continue;
			
			List<Player> listaJugadoresEnMundo = new ArrayList<Player>(mundo.getPlayers());
			if(listaJugadoresEnMundo.isEmpty())continue;
			
			Iterator<Player> iteradorDeJugadores = listaJugadoresEnMundo.iterator();
			while(iteradorDeJugadores.hasNext()){
				Player aj = iteradorDeJugadores.next();
				aj.sendMessage(mensaje);
			}
		}
	}
}
